-- k.yokomizo
library IEEE;
    use IEEE.std_logic_1164.all;
    use IEEE.std_logic_unsigned.all;
entity CNT is
    generic (WIDTH : integer := 1) ;
port(
        CLK    : in std_logic;
        RESETB  : in std_logic;
        INIT : in std_logic;
        MAX    : in std_logic_vector(WIDTH-1 downto 0);
        ENI    : in std_logic;
        ENO    : out std_logic;
        Q     : out std_logic_vector(WIDTH-1 downto 0)
        );
end CNT;

Architecture RTL of CNT is
    signal  CNT : std_logic_vector(WIDTH-1 downto 0);    
 

    
begin
--
--
--
process(CLK,RESETB)
begin
   if(RESETB = '0') then                   -- Reset
      CNT <= (others=>'0') ;
   elsif(CLK'event and CLK = '1')  then   -- CLK event
      if INIT='1' then
        CNT <= (others=>'0');
      elsif ENI='1' then
         if (CNT  = MAX)   then    
            CNT  <= (others=>'0');
         else
            CNT  <= CNT + 1; -- count up
         end if;
      end if;
   end if;
end process;

ENO <= '1' when (ENI='1')and(CNT=MAX) else '0';
Q <= CNT;

end RTL;

