-- k.yokomizo
library IEEE;
    use IEEE.std_logic_1164.all;
    use IEEE.std_logic_unsigned.all;
    
entity TIMER is
generic(
        BASE_MAX_C : std_logic_vector( 17 downto 0) := "101100111111111111");
port(
        CLK     : in std_logic;
        RESETB  : in std_logic;
        ADJUST  : in std_logic;
        CNT_EN   : in std_logic;
        Q_A     : out std_logic_vector(3 downto 0);
        Q_B     : out std_logic_vector(3 downto 0);
        Q_C     : out std_logic_vector(3 downto 0);
        Q_D     : out std_logic_vector(3 downto 0);
        EN_A    : out std_logic;
        MON_0   : out std_logic
        );
end TIMER;

Architecture RTL of TIMER is
    signal  Q_BASE : std_logic_vector(17 downto 0);
    signal  ENO_BASE : std_logic;
    signal  ENO_A     : std_logic;
    signal  ENO_B     : std_logic;
    signal  ENO_C     : std_logic;
    signal  ENO_D     : std_logic;
--    constant BASE_MAX_C : std_logic_vector( 17 downto 0) := "101100111111111111";-- 1/100s=184319(2CFFF)clk ;
--  constant BASE_MAX_C : std_logic_vector( 17 downto 0) := "000000000000010000";
-- TEST_MODE 
    constant CNT_10_MAX_C: std_logic_vector( 3 downto 0) := "1001";
    signal BASE_MAX : std_logic_vector(17 downto 0) ;
    signal CNT_10_MAX : std_logic_vector( 3 downto 0) ;
    signal INIT : std_logic;

    component CNT
        GENERIC
        (
                WIDTH : integer := 1) ;
                
	PORT
	(
		CLK		: IN STD_LOGIC;
		RESETB		: IN STD_LOGIC;
		INIT		: IN STD_LOGIC;
		MAX		: IN STD_LOGIC_VECTOR; 
		ENI             : IN STD_LOGIC;
		ENO		: out STD_LOGIC ;
		Q		: OUT STD_LOGIC_VECTOR 
	);
    end component;

begin

BASE_MAX <= BASE_MAX_C;
CNT_10_MAX <= CNT_10_MAX_C;

EN_A <= ENO_A;
INIT <= '1' when (ADJUST='1')and(CNT_EN='0') else '0';

MON_0 <= Q_BASE(17);

CNT_BASE: CNT
        generic map (
          WIDTH => 18)
        port map( CLK => CLK,
		  RESETB=> RESETB,
                  INIT=> INIT,
                  MAX =>BASE_MAX,
		  ENI => CNT_EN,
		  ENO => ENO_BASE,
                  Q   => Q_BASE );

CNT_A: CNT
        generic map (
                  WIDTH => 4 )
        port map( CLK => CLK,
		  RESETB=> RESETB,
                  INIT=> INIT,
                  MAX => CNT_10_MAX,
		  ENI => ENO_BASE,
		  ENO => ENO_A,
                  Q   => Q_A );

CNT_B: CNT
        generic map (
                  WIDTH => 4 )
        port map( CLK => CLK,
		  RESETB=> RESETB,
                  INIT=> INIT,
                  MAX => CNT_10_MAX,
		  ENI => ENO_A,
		  ENO => ENO_B,
                  Q   => Q_B );


CNT_C: CNT
        generic map (
                  WIDTH => 4 )
        port map( CLK => CLK,
		  RESETB=> RESETB,
                  INIT=> INIT,
                  MAX => CNT_10_MAX,
		  ENI => ENO_B,
		  ENO => ENO_C,
                  Q   => Q_C);
CNT_D: CNT
        generic map (
                  WIDTH => 4 )
        port map( CLK => CLK,
		  RESETB=> RESETB,
                  INIT=> INIT,
                  MAX => CNT_10_MAX,
		  ENI => ENO_C,
		  ENO => ENO_D,
                  Q   => Q_D );

end RTL;





